<template>
  <div
    ref="introOverlayContainer"
    class="is-full is-overlay set-position-fixed transition-standard is-index-10">
    <ProgressBar
      id="videoProgress"
      ref="videoProgressBar"
      class="transition-standard"
      v-bind:currentTime="videoProgress"
      v-bind:durationTime="videoDuration">
    </ProgressBar>
    <VideoBackground
      id="videoIntro"
      class="transition-standard"
      ref="videoBackground"
      v-on:changeProgress="updateProgress($event)"
      v-on:changeDuration="updateDuration($event)"
      v-on:introFinished="hideOverlay">
    </VideoBackground>
    <ActionButton
      msg="Learn more"
      v-bind:method="hideOverlay">
    </ActionButton>
  </div>
</template>

<script>
import VideoBackground from './VideoBackground';
import ActionButton from './ActionButton';
import ProgressBar from './ProgressBar';

export default {
  name: 'IntroPage',
  components: {
    VideoBackground,
    ActionButton,
    ProgressBar,
  },
  data() {
    return {
      videoProgress: 0,
      videoDuration: 0,
    };
  },
  methods: {
    hideOverlay() {
      const overlayContainer = this.$refs.introOverlayContainer;
      const sections = document.getElementsByTagName('section');
      overlayContainer.style.opacity = '0';
      for (let i = 0; i < sections.length; i += 1) {
        sections[i].style.opacity = '1';
      }
      setTimeout(() => {
        overlayContainer.style.display = 'none';
        this.toggleDocumentOverflow();
      }, 1000);
    },
    toggleDocumentOverflow() {
      const overlayContainer = this.$refs.introOverlayContainer;
      const htmlDOMElement = document.documentElement;
      if (overlayContainer.style.display !== 'none') {
        htmlDOMElement.style['overflow-y'] = 'hidden';
      } else {
        htmlDOMElement.style['overflow-y'] = 'scroll';
      }
    },
    updateProgress(updatedProgress) {
      this.videoProgress = updatedProgress;
    },
    updateDuration(updatedDuration) {
      this.videoDuration = updatedDuration;
    },
  },
};
</script>

<style scoped>

</style>
